=== src/jaz/gravis/private/CMakeLists.txt ===
set( install_files
    OBJReader.hxx
    OBJWriter.hxx
    tDeterminants.h
    tImageConverter.hxx
    tImageConvolution.hxx
    tImageIO.hxx
    tImageIO_JPG.hxx
    tImageIO_PNG.hxx
    tImageIO_PNM.hxx
    tRefCPtr.h
    )
INSTALL(FILES ${install_files} 
        DESTINATION
        ${CMAKE_INSTALL_PREFIX}/include/${LIBTITLE}-${LIBVERSION}/${LIBTITLE}/private)
