=== src/jaz/gravis/tImage/CMakeLists.txt ===
set( install_files
    access.hxx
    distance_transform.h
    draw.h
    interpolation.hxx
    normalization.h
    operators.h
    traits.h
    )
INSTALL(FILES ${install_files} 
        DESTINATION
        ${CMAKE_INSTALL_PREFIX}/include/${LIBTITLE}-${LIBVERSION}/${LIBTITLE}/tImage)
