=== debian/changelog ===
relion-cuda (3.1.0-2) unstable; urgency=medium

  * Team upload.
  * Drop myself from Uploaders
  * Add missing Build-Depends: fluid
    Closes: #973776
  * Do not set explicitly old compiler version

 -- Andreas Tille <tille@debian.org>  Sat, 05 Dec 2020 11:56:22 +0100

relion-cuda (3.1.0-1) unstable; urgency=medium

  * Initial upload of this cuda enabled relion version

 -- Roland Fehrenbacher <rfehren@debian.org>  Thu, 01 Oct 2020 10:37:37 +0200
