## relion-cuda 3.1.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -39,7 +39,6 @@
     # add the automatically determined parts of the RPATH
     # which point to directories outside the build tree to the install RPATH
     SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
-
 
     # the RPATH to be used when installing, but only if it's not a system directory
     LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
@@ -231,10 +230,9 @@
 message(STATUS "MPI_C_COMPILER : ${MPI_C_COMPILER}")
 message(STATUS "MPI_CXX_COMPILER : ${MPI_CXX_COMPILER}")
 
-set(SAVE_CMAKE_C_COMPILER ${CMAKE_C_COMPILER})
-set(SAVE_CMAKE_CXX_COMPILER ${CMAKE_CXX_COMPILER})
 SET(CMAKE_C_COMPILER ${MPI_C_COMPILER})
 SET(CMAKE_CXX_COMPILER ${MPI_CXX_COMPILER})
+
 set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
 set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
 set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
@@ -243,31 +241,36 @@
 # ----------------------------------  and build flags including MKL and TBB ---------
 
 message(STATUS "CMAKE_CXX_COMPILER_ID : ${CMAKE_CXX_COMPILER_ID}")
-if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
+
+if(MKLFFT)
+    if (NOT "$ENV{MKLROOT}" STREQUAL "")
+        include_directories("$ENV{MKLROOT}/include/fftw")
+        message(STATUS "MKL FFTW wrapper header files: $ENV{MKLROOT}/include/fftw")
+    else()
+        message("COMPILATION MAY FAIL since no MKL FFTW wrapper header files could be found. Please make sure the MKLROOT environmental variable is set.")
+    endif()
+    add_definitions(-DMKLFFT)
+endif(MKLFFT)
+
+if("${CMAKE_CXX_COMPILER_ID}" MATCHES "Intel" OR "${CMAKE_CXX_COMPILER}" MATCHES "icpx")
+# "Intel" is for classic Intel compiler and "IntelLLVM" is for oneAPI compiler which is supported from CMake 3.20
     if(MKLFFT)
-        SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fopenmp -mkl -limf ")
-    	add_definitions(-DMKLFFT)
+        if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
+            SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -qopenmp -mkl=parallel -limf ")
+        else()	# Intel oneAPI compiler
+            SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fiopenmp -mkl=parallel -limf ")
+        endif()
     endif(MKLFFT)
     if(ALTCPU)
         add_definitions(-DFAST_CENTERFFT)
     endif()
-    SET(CudaTexture OFF)
-    SET(CMAKE_C_COMPILER ${SAVE_CMAKE_C_COMPILER})
-    SET(CMAKE_CXX_COMPILER ${SAVE_CMAKE_CXX_COMPILER})
-    SET(MPI_C_COMPILER ${SAVE_CMAKE_C_COMPILER})
-    SET(MPI_CXX_COMPILER ${SAVE_CMAKE_CXX_COMPILER})
 else()
     if(MKLFFT)
         # For the time being, let's use the sequential version (as with FFTW)
-        SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -lmkl_intel_ilp64 -lmkl_core -lmkl_sequential ")
-        add_definitions(-DMKLFFT)
+        link_directories("$ENV{MKLROOT}/lib/intel64")
+        SET(FFTW_LIBRARIES mkl_intel_lp64 mkl_sequential mkl_core)
     endif(MKLFFT)
 endif()
-
-message(STATUS "CMAKE_C_COMPILER : ${CMAKE_C_COMPILER}")
-message(STATUS "CMAKE_CXX_COMPILER : ${CMAKE_CXX_COMPILER}")
-message(STATUS "MPI_C_COMPILER : ${MPI_C_COMPILER}")
-message(STATUS "MPI_CXX_COMPILER : ${MPI_CXX_COMPILER}")
 
 if(ALTCPU)
     add_definitions(-DALTCPU)
@@ -305,5 +308,3 @@
 	endif(NOT FLTK_FOUND)
 
     else(X11_FOUND)
-        message( STATUS "\n-- ------------------ YOU HAVE NO X11-LIBS ------------------")
-        message( STATUS "CCmake found no X11-libs on your system, which are required for the GUI.")
