=== src/apps/CMakeLists.txt ===
--- 
+++ 
@@ -19,8 +19,14 @@
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/")
 include(GetGitRevisionDescription)
 get_git_head_revision(GIT_REFSPEC GIT_SHA1_FULL)
-string(SUBSTRING ${GIT_SHA1_FULL} 0 6 GIT_SHA1)
-message(STATUS "Git commit ID: ${GIT_SHA1_FULL}")
+set(RELION_VERSION_SUFFIX "")
+if (GIT_SHA1_FULL)
+   string(SUBSTRING ${GIT_SHA1_FULL} 0 6 GIT_SHA1_PREFIX)
+   if (NOT GIT_SHA1_PREFIX STREQUAL "GITDIR")
+      message(STATUS "Git commit ID: ${GIT_SHA1_FULL}")
+      set(RELION_VERSION_SUFFIX "-commit-${GIT_SHA1_PREFIX}")
+   endif()
+endif()
 configure_file("${CMAKE_SOURCE_DIR}/src/macros.cpp.in" "${CMAKE_BINARY_DIR}/macros.cpp" @ONLY)
 
 if (ALTCPU)
@@ -60,7 +66,7 @@
 file(GLOB REL_HP "${CMAKE_SOURCE_DIR}/src/Healpix_2.15a/*.cc")
 file(GLOB RELION_TARGETS "${CMAKE_SOURCE_DIR}/src/apps/*.cpp")
 
-set(GUI_TARGETS display maingui manualpick pipeliner)
+set(GUI_TARGETS maingui display manualpick)
 
 #--Remove apps using X11 if no GUI--
 if(NOT GUI)
@@ -71,7 +77,7 @@
 
 #--Remove apps for testing--
 #SET(RELION_TEST TRUE)
-set(TEST_TARGETS double_reconstruct_openmp cs_fit ctf_nyquist_test free_aberration_plot split_stack defocus_stats double_bfac_fit interpolation_test motion_diff paper_data_synth Zernike_test vis_delocalisation vis_Ewald_weight)
+set(TEST_TARGETS movie_reconstruct double_reconstruct_openmp cs_fit ctf_nyquist_test free_aberration_plot split_stack defocus_stats double_bfac_fit interpolation_test motion_diff paper_data_synth Zernike_test vis_delocalisation vis_Ewald_weight)
 if(NOT RELION_TEST)
 	foreach(TARGET ${TEST_TARGETS})
 		list(REMOVE_ITEM RELION_TARGETS "${CMAKE_SOURCE_DIR}/src/apps/${TARGET}.cpp")
@@ -194,13 +200,18 @@
 
 foreach (_target ${RELION_TARGETS})
 	GET_FILENAME_COMPONENT(_target "relion_${_target}" NAME_WE)  #specify target name WE=WithoutExtension
-	
-	add_executable(${_target} ${_target}.cpp )
+
+	if(${_target} STREQUAL "maingui") # We no longer want "relion_maingui"
+		set(_target "relion")
+		add_executable(${_target} maingui.cpp)
+	else()
+		add_executable(${_target} ${_target}.cpp )
+		set_target_properties(${_target} PROPERTIES PREFIX "relion_")
+	endif()
+
 	set(LIB relion_lib)
 	
  	add_dependencies(${_target} relion_lib)
-	
-	set_target_properties(${_target} PROPERTIES PREFIX "relion_")
 
 	if(NOT MKLFFT)
 		target_link_libraries(${_target} ${LIB} ${EXTRA_LIBS} ${MPI_LIBRARIES} ${CMAKE_DL_LIBS})
@@ -223,7 +234,7 @@
 	)
 	
 	list(FIND GUI_TARGETS ${_target} IS_GUI_TARGET)
-	if(NOT ${IS_GUI_TARGET} LESS 0)
+	if((NOT ${IS_GUI_TARGET} LESS 0) OR (${_target} STREQUAL "relion"))
 		add_dependencies(${_target} relion_gui_lib)
 		target_link_libraries(${_target} relion_gui_lib ${FLTK_LIBRARIES} ${X11})
 	endif()
@@ -236,14 +247,6 @@
 	
 	install (TARGETS ${_target} RUNTIME DESTINATION bin)
 endforeach()
-
-if(GUI)
-	ADD_CUSTOM_COMMAND(TARGET maingui
-	                   POST_BUILD
-                           COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_BINARY_DIR}/bin/relion_maingui ${PROJECT_BINARY_DIR}/bin/relion
-                           COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_BINARY_DIR}/bin/relion_qsub.csh ${PROJECT_BINARY_DIR}/bin/qsub.csh
-	)
-endif(GUI)
 
 FIND_PACKAGE( OpenMP REQUIRED)
 if(OPENMP_FOUND)
