=== debian/changelog ===
relion-cuda (3.1.3-2) unstable; urgency=medium

  * Team upload.
  * Fix watch file
  * Rebuild for the libtiff5 -> libtiff6 transition
    Closes: #1029179

 -- Andreas Tille <tille@debian.org>  Thu, 19 Jan 2023 07:57:26 +0100

relion-cuda (3.1.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream version.
  * Build using cuda-gcc.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 29 Sep 2022 14:56:00 +0200

relion (3.1.3-2) unstable; urgency=medium

  [ Andreas Beckmann ]
  * Team upload.
  * Cherry-pick upstream fixes related to cub.  (Closes: #995224)
  * Simplify debian/rules.
  * Fix missing hardening flags.
  * Build for Architecture: any.
  * Standards-Version: 4.6.1.
  * Fix some typos found by Lintian.

  [ Andreas Tille ]
  * Enable uscan to create a sensible download name

 -- Andreas Beckmann <anbe@debian.org>  Thu, 29 Sep 2022 13:27:08 +0200

relion (3.1.3-1) unstable; urgency=medium

  * Fix watchfile to detect new versions on github
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)
  * Update renamed lintian tag names in lintian overrides.
  * Mark autopkgtest superficial

 -- Andreas Tille <tille@debian.org>  Tue, 19 Oct 2021 09:16:04 +0200

relion (3.1.0-4) unstable; urgency=medium

  * Drop useless get-orig-source target (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Build-Depends: fluid

 -- Andreas Tille <tille@debian.org>  Wed, 07 Oct 2020 16:03:12 +0200

relion (3.1.0-3) unstable; urgency=medium

  * relion-cuda and relion-gui-cuda are now built by src:relion-cuda/contrib.

 -- Roland Fehrenbacher <rfehren@debian.org>  Thu, 01 Oct 2020 10:37:37 +0200

relion (3.1.0-2) unstable; urgency=medium

  * New upstream version 3.1.0
  * Update to Standards-Version: 4.5.0
  * Rename available binary packages, since MPI support is now default.
    The MPI enabled binaries carry a suffix _mpi, serial versions are still
    available.
  * Dropped librelion* packages. No shared libraries are created by relion
    anymore.
  * Add versions with CUDA/GPU support (these are in the Debian contrib
    archive area). They are named relion-cuda and relion-gui-cuda.
  * Moved to dep14 layout to work directly with the upstream git repo (see
    README.source in the source archive).
  * Added a simple autopkgtest

 -- Roland Fehrenbacher <rfehren@debian.org>  Tue, 29 Sep 2020 19:01:31 +0000

relion (1.4+dfsg-4) unstable; urgency=medium

  * Team upload.
  * Add watch file (and delete README.source that explains why there is no
    watch file)
  * New upstream version
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.1.4
  * Restrict architectures to amd64 and i386
    Closes: #897239

 -- Andreas Tille <tille@debian.org>  Thu, 14 Jun 2018 14:10:42 +0200

relion (1.4+dfsg-3) unstable; urgency=medium

  * Team upload
  * d/control: Enable all archs, Closes: #873865
  * d/control: Update standards to 4.1.1 (no changes)

 -- Gert Wollny <gewo@debian.org>  Thu, 07 Dec 2017 10:27:59 +0100

relion (1.4+dfsg-2) unstable; urgency=medium

  [ Gert Wollny ]
  * Team upload.
  * d/p/0005: Correct compilation with gcc-6, Closes: #811641
  * d/p/0006: Correctly copy only 4 byte, corresponding to the
    target array size
  * d/control: Update standards version to 3.9.8

  [ Andreas Tille ]
  * hardening=+bindnow

 -- Gert Wollny <gw.fossdev@gmail.com>  Wed, 29 Jun 2016 13:32:34 +0000

relion (1.4+dfsg-1) unstable; urgency=medium

  [ Roland Fehrenbacher ]
  * New upstream version 1.4
  * Bug fix: "file conflicts between librelion{+mpi}{+gui}-1.3-1{v5}
    packages", thanks to Ralf Treinen (Closes: #797825).

  [ Andreas Tille ]
  * Enable building architecture independant files separately
    Closes: #806103

 -- Roland Fehrenbacher <rf@q-leap.de>  Tue, 08 Dec 2015 19:04:50 +0100

relion (1.3+dfsg-3) unstable; urgency=medium

  [ Andreas Tille ]
  * Rename library packages for g++5 ABI transition.
    (Thanks for the patch to Iain Lane <iain@orangesquash.org.uk>)
    Closes: #791267

  [ Roland Fehrenbacher ]
  * Fix permissions of d/lib*.install files (needed for dh-exec)

 -- Roland Fehrenbacher <rf@q-leap.de>  Mon, 24 Aug 2015 16:08:36 +0000

relion (1.3+dfsg-2) unstable; urgency=medium

  * Drop build-dep on openmpi-gcc
    Closes: #766821

 -- Andreas Tille <tille@debian.org>  Sun, 26 Oct 2014 07:40:11 +0100

relion (1.3+dfsg-1) unstable; urgency=low

  * Initial upload (Closes: #766324)

 -- Roland Fehrenbacher <rf@q-leap.de>  Thu, 23 Oct 2014 11:52:48 +0000
