=== debian/control ===
--- 
+++ 
@@ -9,16 +9,16 @@
                libfltk1.3-dev,
                libopenmpi-dev,
                libtiff-dev,
-               nvidia-cuda-toolkit,
+               nvidia-cuda-toolkit-gcc,
                fluid
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/med-team/relion
 Vcs-Git: https://salsa.debian.org/med-team/relion.git
 Homepage: https://www2.mrc-lmb.cam.ac.uk/relion/index.php/Main_Page
+Rules-Requires-Root: no
 
 Package: relion-cuda
-Section: contrib/science
-Architecture: amd64 i386
+Architecture: any
 Depends: openmpi-gcc | openmpi-bin,
          ${misc:Depends},
          ${shlibs:Depends},
@@ -43,9 +43,9 @@
  CUDA/GPU support.
 
 Package: relion-gui-cuda
-Architecture: amd64 i386
-Depends: openmpi-gcc | openmpi-bin,
-         relion-cuda,
+Architecture: any
+Depends:
+         relion-cuda (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends},
 Breaks: relion-bin,
@@ -57,7 +57,7 @@
           relion-bin+mpi,
           relion-bin+mpi+gui,
 Conflicts: relion-gui,
-Description: parallel toolkit for 3D reconstructions in cryo-electron microscopy
+Description: toolkit for 3D reconstructions in cryo-electron microscopy (gui apps)
  RELION (for REgularised LIkelihood OptimisatioN) is a stand-alone
  computer program for Maximum A Posteriori refinement of (multiple) 3D
  reconstructions or 2D class averages in cryo-electron microscopy.
