=== debian/tests/control ===
Test-Command: /usr/bin/relion_refine
Depends: relion-cuda
Restrictions: superficial
